#include <iostream>
#include <string>

using namespace std;

/*
   "(*)（O-O)      <--(<_<)"; //Wait, it's the always has been meme? 
   "(>_<)->     (^._.^)"; //Women yelling at cat meme
   
   1. Készítsünk egy Meme osztály.
   Két string típusú adattagja van, láthatóságuk legyen privát. Nevük: szoveg, kep.
   Legyen hozzá két paraméteres konstruktor, amivel beállítjuk az adattagokat.
   Írj gettereket is! 
*/

class Meme{
    string szoveg, kep;
    
public:
    Meme(const string& kep, const string& sz): szoveg(sz), kep(kep){
        //this->szoveg = szoveg;
    }
    
    //Meme(){}
    Meme() = default;
    
    const string& get_szoveg()const{
        return szoveg;
    }
    
    const string& get_kep()const{
        return kep;
    }
    
};

/*
 2. Készíts egy void print_meme() metódust, melynek paramétere egy >konstans< Meme referencia.
   Egy sorban kiírja a meme szövegét majd egy rákövetkező sorban a képet is.
   Hogyan kell módosítani az előbb megírt gettereket?

*/

void print_meme(const Meme& m){
    cout << m.get_szoveg() << endl << m.get_kep() << endl;
}

/*
 3. Készíts egy MemeGyujtemeny osztályt.
   Ez maximum tíz Memét tud letárolni egy tömbben.
   Mivel kell kiegészíteni a Meme osztályt, hogy működjön a tömb létrehozás?
*/

/*
 4. Definiáld felül a & és a &= operátorokat a MemeGyujtemeny osztályban úgy, hogy a baloldali operandus egy MemeGyujtemeny legyen, a jobboldali pedig egy Meme.
   MemeGyujtemeny mgy;
   Meme meme;
   MemeGyujtemeny mgy2 = mgy & meme;
   MemeGyujtemeny k;
   k+=meme;
    
    A MemeGyujtemeny tömbjében az első üres helyre kerüljön be az új meme.
   Módosítsuk úgy a MemeGyujtemeny osztályt, hogy le tudja tárolni aktuálisan hány meme-t tárol!
   MemeGyujtemeny & Meme esetén ne legyen módosítva egyik operandus sem, a visszatérési érték pedig egy lemásolt, bővített MemeGyujtemeny objektum legyen.
   MemeGyujtemeny &= Meme esetén a bal oldali MemeGyujtemeny objektum módosuljon. MemeGyujtemeny referencia legyen visszaadva.
   Ha nincs már hely ne legyen hozzáadás, csak történjen meg a megfelelő típusok visszadaása (módosítás nélküli másolat, bal oldali operandus)

*/

/*
 5. Definiáld felül az indexer [] operátort a MemeGyujtemeny osztályban. 
  * Túlindexelés esetén legyen kiírva a Hiba szöveg a cout-ra és a 0-ás indexű meme legyen visszaadva.
*/

class MemeGyujtemeny{
    Meme gyujtemeny[10];
    unsigned aktualis_meme_szam = 0;
    
public:
    unsigned get_aktualis_meme_szam()const{
        return aktualis_meme_szam;
    }
    
    void set_aktualis_meme_szam(unsigned aktualis_meme_szam){
        this->aktualis_meme_szam = aktualis_meme_szam;
    }
    
    MemeGyujtemeny operator&(const Meme& meme)const{
        MemeGyujtemeny mgy = *this;
        if(mgy.aktualis_meme_szam < 10){
            mgy.gyujtemeny[mgy.aktualis_meme_szam] = meme;
            mgy.aktualis_meme_szam++;
        }
        return mgy;
    }
    
    MemeGyujtemeny& operator&=(const Meme& meme){
        if(aktualis_meme_szam < 10){
            gyujtemeny[aktualis_meme_szam] = meme;
            aktualis_meme_szam++;
        }
        return *this;
    }
    
    Meme& operator[](unsigned i){
        if(i >= aktualis_meme_szam){
            cout << "Hiba" << endl;
            return gyujtemeny[0];
        }
        return gyujtemeny[i];
    }
    
    const Meme& operator[](unsigned i)const{
        if(i >= aktualis_meme_szam){
            cout << "Hiba" << endl;
            return gyujtemeny[0];
        }
        return gyujtemeny[i];
    }
};

void print_gyujtemeny(const MemeGyujtemeny& mgy){
    for(unsigned i=0;i<mgy.get_aktualis_meme_szam();++i){
        print_meme(mgy[i]);
        cout << "----" << endl;
    }
}



int main(int argc, char **argv)
{
    Meme m1("(*)（O-O)      <--(<_<)", "Wait, it's the always has been meme? Always has been");
    print_meme(m1);
    
    //Meme m2("kepet allitom csak be");//szoveg ures
    //Meme m3;
    
    MemeGyujtemeny mgy;
    
    cout << mgy.get_aktualis_meme_szam() << endl;
    MemeGyujtemeny mgy2 = mgy & m1;
    cout << mgy.get_aktualis_meme_szam() << endl;
    cout << mgy2.get_aktualis_meme_szam() << endl;
    
    mgy2&=m1;
    cout << mgy2.get_aktualis_meme_szam() << endl;
    (mgy2&=m1)&=m1;
    cout << mgy2.get_aktualis_meme_szam() << endl;
    
    //cout << mgy2[5].get_kep() << endl << mgy2[5].get_kep() << endl;
    //print_meme(mgy2[1]);
    
    print_gyujtemeny(mgy2);
	return 0;
}
