#include <iostream>
#include <string>

using namespace std;

/*
   Készíts egy Zene osztályt. Adattagjai: hossz (egész szám, másodpercben értve), nev.
   A nev default értéke legyen: "a-moll". 
   Legyen egy print() metódusa, amely kiíratja cout-ra az értékeit. 
   Legyen egy két paraméteres konstruktora és egy egy paraméteres is, amiben csak a hosszt lehet állítani. 
   Ne lehessen int-et impliciten Zene osztályra konvertálni.
 */
 
 
/*
 Legyen megvalósítva a Zene+int operátor, ami az előző Zene alapján készít egy új, megnövelt hosszúságú zenét.
 Legyen megvalósítva az int+Zene operátor, ami az előző Zene alapján készít egy új, megnövelt hosszúságú zenét.
*/

/*
 Legyen megvalósítva a Zene+=int operátor, mely a paraméterben kapott értékkel növeli a zene hosszát.
*/

/*
 Legyen megvalósítva a Zene osztályra prefix és a postfix ++ operátor is, ami növeli 1-gyel a zene hosszát.
*/
 
class Zene{
    int hossz;
    string nev;
    friend Zene operator+(int plusz, const Zene& z);
public:
    explicit Zene(int hossz, const string& nev = "a-moll"):
        hossz(hossz), nev(nev){
    }
    
    void print()const{
        cout << "Zene neve:" << nev << " hossza:" << hossz << " mp" << endl;
    }
    
    Zene operator+(int plusz)const{
      Zene z(hossz + plusz, nev);
      return z;
    }
    
    Zene& operator+=(int plusz){
        hossz += plusz;
        return *this;
    }
    
    //prefix
    Zene& operator++(){
        hossz++;
        return *this;
    }
    
    //postfix
    Zene operator++(int){
        Zene tmp = *this;
        operator++();
        return tmp;
    }
    
};

Zene operator+(int plusz, const Zene& z){
      Zene z_uj(z.hossz + plusz, z.nev);
      return z_uj;
}

int main(int argc, char **argv)
{
    Zene z(100, "c-dur");
    Zene z2(200);
    
    z.print();
    z2.print();
    
    Zene z3 = z + 200;
    
    z3.print();
    
    Zene z4 = 200 + z;
    
    z4.print();
    
    (z4 += 120) += 100;
    z4.print();
    
    Zene z5 = ++z4 + 1;
    z5.print();
    
    Zene z6 = z5++ + 100;
    z6.print();
    z5.print();
	return 0;
}