#include <iostream>
#include <string>

using namespace std;

class allat{
protected:
    bool novenyevo;
public:
    allat(bool n, unsigned k):novenyevo(n){
        cout << "allat letrehozva" << endl;
    }
    
    virtual ~allat(){
        cout << "allat torolve" << endl;
    }
    
    virtual void taplalkozik()const{
        if(novenyevo){
            cout << "legel" << endl;
        }
        else{
            cout << "vadaszik" << endl;
        }
    }
};

class macska: public allat{
    string nev;
public:
    macska(const string& n): allat(false, 38), nev(n){
        cout << "macska letrehozva:" << endl;
    }
    
    ~macska(){
        cout << "macska torolve" << endl;
    }
    
    void taplalkozik()const override{
        cout << nev << " egeret ";
        allat::taplalkozik();
    }
};

//ertek
void etet(allat a){
   a.taplalkozik(); 
}
//referencia
void etet_ref(const allat& a){
   a.taplalkozik(); 
}
//pointer szerinti
void etet(allat* a){
   a->taplalkozik(); 
}


int main(){
    /*allat a(false);
    macska m("Mimi");
    
    etet_ref(a);
    etet_ref(m);
    
    etet(&a);
    etet(&m);
    
    etet(a);
    etet(m);*/
    allat * m = new macska("Mimi");
    m->taplalkozik();
    delete m;
    
    
}