#include <iostream>

using namespace std;

class SIMKartya {
private:
  string szam;
public:
  SIMKartya(string p_szam) {
    szam = p_szam;
  }
  
  string get_szam() {
    return szam;
  }
};

class Telefon {
  SIMKartya *kartya = nullptr;
public:
  void kartya_hozzaadas(SIMKartya *kartya) {
    this->kartya = kartya;
  }
  
  void kartya_kivetel() {
    kartya = nullptr;
  }
  
  string get_telefonszam() {
    return kartya->get_szam();
  }
};

void kartya_csere(Telefon telefon, SIMKartya uj_kartya) {
  cout << "A telefon szama: " << telefon.get_telefonszam() << endl;
  telefon.kartya_hozzaadas(&uj_kartya);
  cout << "A telefon uj szama: " << telefon.get_telefonszam() << endl;
}

int main() {
  SIMKartya sim("123456");
  cout << "A kartya szama: " << sim.get_szam() << endl;
  
  Telefon telefon;
  telefon.kartya_hozzaadas(&sim);
  cout << "A telefon szama: " << telefon.get_telefonszam() << endl;
  
  SIMKartya uj_kartya("333444");
  kartya_csere(telefon, uj_kartya);
  cout << "A telefon uj szama: " << telefon.get_telefonszam() << endl;
}
