// default member init.

#include <iostream>
#include <string>

using namespace std;

class Kurzus {
  string nev, kod;
  unsigned max = 25;
public:
  Kurzus(string nev, string kod) : nev(nev), kod(kod) {
  }

  Kurzus(string nev, string kod, int max) : nev(nev), kod(kod), max(max) {
  }

  string get_nev() {
    return nev;
  }

  string get_kod() {
    return kod;
  }

  unsigned get_max() {
    return max;
  }
};

int main() {
  string nev, kod;
  int max;
  cin >> nev >> kod >> max;
  Kurzus k(nev, kod, max);
  cout << k.get_nev() << " (" << k.get_kod() << ", max: " << k.get_max() << ")" << endl;
  Kurzus k2(nev, kod);
  cout << k2.get_nev() << " (" << k2.get_kod() << ", max: " << k2.get_max() << ")" << endl;
}
