// cim szerinti atadas referencia segitsegevel

#include <iostream>
#include <string>

using namespace std;

class Kurzus {
  string nev, kod;
  unsigned max;
public:
  Kurzus(string nev, string kod) : Kurzus(nev, kod, 25) {
  }

  Kurzus(string nev, string kod, int max) : nev(nev), kod(kod), max(max) {
  }

  string get_nev() {
    return nev;
  }

  string get_kod() {
    return kod;
  }

  unsigned get_max() {
    return max;
  }

  // hibakezelessel nem foglalkozunk
  void letszam_valtozas(int valtozas) {
    max += valtozas;
  }
};

// szandekosan nem a Kurzus osztaly metodusa
void letszam_valtoztatas(Kurzus* k) {
  int valtozas;
  cin >> valtozas;
  k->letszam_valtozas(valtozas);
}

void letszam_valtoztatas(Kurzus& k) {
  int valtozas;
  cin >> valtozas;
  k.letszam_valtozas(valtozas);
}

int main() {
  string nev, kod;
  int max;
  cin >> nev >> kod >> max;
  Kurzus k(nev, kod, max);
  cout << k.get_nev() << " (" << k.get_kod() << ", max: " << k.get_max() << ")" << endl;
  letszam_valtoztatas(&k);
  cout << k.get_nev() << " (" << k.get_kod() << ", max: " << k.get_max() << ")" << endl;
  letszam_valtoztatas(k);
  cout << k.get_nev() << " (" << k.get_kod() << ", max: " << k.get_max() << ")" << endl;
}
