#include <iostream>
#include <string>

using namespace std;

class Hallgato {
  string nev, kod;
public:
  Hallgato() {
  }

  Hallgato(const string& nev, const string& kod) : nev(nev), kod(kod) {
  }
  
  const string& get_nev() const {
    return nev;
  }
  
  const string& get_kod() const {
    return kod;
  }
};


class Kurzus {
  string nev, kod;
  unsigned felvette = 0;
  Hallgato hallgatok[10];
public:
  Kurzus(const string& nev, const string& kod) : nev(nev), kod(kod) {
  }

  const string& get_nev() const {
    return nev;
  }

  const string& get_kod() const {
    return kod;
  }
};


int main() {
  Hallgato h1("Kiss Geza", "A1B2C3"), h2("Szabo Anna", "DEF456");
  Kurzus k("Programozas II.", "IB302G-1");

  cout << h1.get_nev() << ", " << h1.get_kod() << endl;
  cout << h2.get_nev() << ", " << h2.get_kod() << endl;
  cout << k.get_nev() << ", " << k.get_kod() << endl;
}
